WSITES01 - Editorial

Problem Link

Practice

Contest

Author: Azat

Tester: Pawel Kacprzak and Misha Chorniy

Editorialist: Bhuvnesh Jain

Difficulty

EASY-MEDIUM

Prerequisites

Tries, State Transitions

Problem

You are given a list of websites, some of which are blocked. You need to find a set of prefixes such that each of the blocked websites are recognised by some prefix but none of the non-blocked websites are. The aim is to minimise the sum of the length of the prefixes found.

Quick Explanation

Build a tries of the words, storing information regarding the words, their type (blocked or non-blocked). Use transitions during the traversal of trie (dfs) to find the optimal answer, if it exists.

Explanation

First of all, the problem deals with prefixes. Generally, problems on strings related to prefixes can be solved using hashing or trie. We will use trie to solve this problem.

Before starting to solve the problem, like what kind of data structure we would require and what information it should store, let us first analyse when the solution exists or not. The solution will not exist only when the blocked site is a prefix of a non-blocked website.. In all other cases the solution will exist because in the worst case, we might select the whole word for all the blocked websites.

Now, suppose the solution exist. We would like to minimise the total length of the selected prefixes. Now, since the length of one prefix is independent of the other, the total length would be minimum when we minimise each prefix selected. For minimising each prefix selected, we just want to selected the first character which differentiates between 2 blocked and non-blocked websites. Such a letter will exist as otherwise the solution would not have existed.

Let us understand this through examples. Let the blocked website be “codeforces” and allowed website be “codechef”. Now, the 5^{th} letter (“f” vs “c”) is the one which differentiates the 2 websites. Let the blocked website be “bing” and allowed website be “google”. In this case, the 1^{st} letter will only differentiate the 2 websites. Let the blocked be “cs” and allowed website be “csacademy”. In this case the solution will definitely not exist. As all the prefixes, “c” and “cs” would block both the websites.

From the examples, above our data structure should be able to handle 2 type of operations. They are :

  1. Detecting whether the blocked website is a prefix of any non-blocked website.
  2. Finding efficiently the first point of difference between 2 websites names.

Doing this through brute force will take complexity O(\sum_{i=1}^{i=n} \sum_{j=i+1}^{j=n} min(L_i, L_j), where L_i = length of string i. This is because the comparison between 2 strings to do the above operations can be done using a simple for loop, which terminates in worst case when either of the string to be processed finishes. In the worst case, it will be quadratic in the sum of length of strings given. Thus, it will only be able to solve subtask 1. For the complete solution, we use tries and store the following information in it to be able to handle above operations efficiently.

  1. State 0 = no websites.
  2. State 1 = non-blocked websites only.
  3. State 2 = blocked websites only.
  4. State 3 = both blocked and non-blocked websites.

After building of the trie, we just do a traversal (dfs) on it. Now, few things should be noted. Whenever we are in state 3, we can go to state \{0, 1, 2, 3\} in the child node. When we are in state 1, we can only go to state \{0, 1\} and when we are in state 2, we can only go to \{0, 2\} in the child node. This information will be enough to be able to handle above operations. Below are the claims for it :

  1. Whenever, we make have a node at state 3 and all of its children have state \{0, 1\} only, we see that a blocked website is a prefix of a non-blocked website. Thus we should terminate our search here and claim that it is “impossible” to constrict an answer.
  2. Otherwise in all cases, the solution exist. To find the minimal length, whenever we see that a state 3, has a child with states \{0, 1, 2\}, we are sure to have found a point of difference between the blocked websites and non-blocked websites. This is when we should stop are search together on this current branch and add the required prefix to our solution.
  3. Otherwise, the whole search space would only consist of wither blocked or non-blocked websites. This is easy as non-blocked website are not required to be searched. Also, for blocked websites, the 1^{st} character would only differentiate between the blocked and non-blocked website and thus we can terminate the search here too.

All the above operations can be done in O(\sum_{i=1}^{i=n} {L}_{i}), where L_i = length of string i. This is because the trie can be build in above complexity and can be traversed in above complexity too.

If you had some other logic/algorithm to solve the above problem, feel free to discuss below

Time Complexity

O(\sum_{i=1}^{i=n} {L}_{i}), where L_i = length of string i

Solution Links

Setter’s solution

Tester’s solution

Editorialist solution

2 Likes

What!! I just did it by 2 pointer technique. And I think most of the people would have used this method only or binary search as the number of submissions were > 1700 and surely a trie problem would get < 400-500 submissions at max.

1 Like

Simpler Approach:
Lexographicaly sort both the arrays(representing elements to include/not).Then calculate the upper bound for each element you want to include in the other array.


[1]


  [1]: https://www.codechef.com/viewsolution/13576049

I did it using trie, brute force implementation using trie is sufficient!

I did it by tweaking the brute force using maps and that’s all was needed for AC
check out my solution CodeChef: Practical coding for everyone

1 Like

sort the array lexographically, go to each ‘-’ string and find the nearest ‘+’ string above and below it.
compare the given ‘-’ string with both the ‘+’ strings and find the string with maximum number of continuous matching characters from the beginning and load that substring into a treeset(to avoid duplicates). print the treeset

Does Codechef provide testcases? It would be helpful for knowing corner cases and debugging.

I solved the question using mentioned data structure i.e. trie and set, however got WA on two cases in subtask 2. Here is the solution. If someone using same logic could point out the error or provide corner test case, it would be great help.
Thanks in advance.

I did it using tries, normal tries and it gets accepted.
Here is my solution CodeChef: Practical coding for everyone
Also can you guys please vote my post. I need karma for posting questions.

8 Likes

You can implement it using the binary search tree with the method compareTo method in java… Pretty fast

Lexicographically sort both arrays (used a map<string, int> for this). Now insert each blocked site into the map of unblocked sites. You’ll get upper/lower bounds in O(log n) time. Get the maximum sized prefix by comparing just 2 elements. Add this prefix to final list of filters. You only need to check if the new prefix is a prefix of the last added element in the list of filters or not. (since you took sorted arrays initially, you’ll also get the filters sorted).


[1]


  [1]: https://www.codechef.com/viewsolution/13600585

@devilhector I could’nt point out the mistake in your code but i have use the same data structure Tries and Set CodeChef: Practical coding for everyone. u can see your self if its fairly understandable code. hope it help

Did it using Trie(2-D array implementation).
https://www.codechef.com/viewsolution/13598320

Hi,
Please help me out, as I was unable to identify for which test case my code is failing. My code was unable to pass two test cases. Kindly have a look & suggest link to solution is : code

https://www.codechef.com/viewsolution/13976703

Can any one tell me any tc on which this soln fails???

I have tried alot to solve this problem

I implemented it using nested dictionaries. I realise this is inefficient, but can someone tell me what testcase mine isn’t working on ?

https://www.codechef.com/viewsolution/13598055

Hi
I am using Trie for solving this… Total 3 TCs are failing . Could somebody help me…
https://www.codechef.com/viewsolution/14361002
Please help me…

Hi I have tried all below TCs all are running fine . but I am getting WA in two TCs Please suggest any TC which I am missing

4

+ youtube
+ abcd
+ abcdchef
+ zzyy

Output
0

//// all negative

5
- abcdchef
- youtube
- youtubeisbest
- google
- googled
Output :
3
a
g
y

/// show strings in sorted order

6
+ google
+ googld
- googles
- googlea
- googlds
- googldr
OUTPUT :
4
googldr
googlds
googlea
googles

/////////
Any mathched -ve string shorter then positive

4
+ google
+ googld
- goog
- googles
OUTPUT :
-1

//////
Any mathched +ve string Longer then negative

3
- goog
- googles
+ google
OUTPUT :
-1

//same string its not allowed but still i checked this

2
- abc
+ abc
OUTPUT
-1
enter code here
1 Like

this weird , the setter’s and tester’s solution link is just the link to editorial again

Hi,anyone can help me figure out the problem below ?

the only difference for this two solution is

int n;
char c;
scanf("%d",&n);
for(int i = 0; i < n; i++)
{
    getchar();
    c = getchar();
    cin >> s;

and

int n;
char c;
scanf("%d",&n);
for(int i = 0; i < n; i++)
{
    cin >> c >> s;

the first one gets wrong answer, but the second one gets accepted.

the first solution link text

the second solution link text

but in local enviroment, I tested the first one , it can input and output normally with the samples.

thanks XD